#!/usr/bin/perl -w
use strict;

my $max = shift || 10;
my $edges = shift || 2;
my $tief = shift || 3;

print "<?xml version=\"1.0\"?>\n";
print "<xml>\n";
level(0, "0");

sub level {
  my $t = shift;
  my $name = shift;

  my $child_name; 
  for (my $n = 0; $n < $max; $n++) {
    $child_name = $name . "-$n";
    print "  <node>\n";
    print "    <name>$child_name</name>\n";
    print "    <type>default</type>\n";
    print "    <category>composite</category>\n";
    if ($t < $tief) { level($t+1, $child_name); }
    print "  </node>\n";
  }
  my $nn = 0;
  for (my $n = 0; $n < $max; $n++) {
    for (my $e = 0; $e < $edges; $e++) {
      do { $nn = int(rand $max); } until ($nn != $n);
      print "  <edge>\n";
      print "    <name>$child_name-$e</name>\n";
      print "    <type>default</type>\n";
      print "    <category>edge</category>\n";
      print "    <from>$name-$n</from>\n";
      print "    <to>$name-$nn</to>\n";
      print "  </edge>\n";
    }
  }
}

print "</xml>\n";
exit 0;

